<?php
/*
Plugin Name: مکمل افزونه پیامک وردپرس wp-sms برای ippanel
Version: 1.1
Description: این افزونه امکان استفاده از سامانه های پیامکی ippanel را در افزونه پیامک وردپرس فراهم میکند. حتما به همراه افزونه پیامک وردپرس استفاده شود.
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
function wp_sms_ippanel_activate() {
  if ( ! function_exists( 'is_plugin_active' ) ) {
    include_once( ABSPATH . '/wp-admin/includes/plugin.php' );
  }
  if ( current_user_can( 'activate_plugins' ) && !is_plugin_active( 'wp-sms/wp-sms.php' ) ) {
    // Deactivate the plugin.
    deactivate_plugins( plugin_basename( __FILE__ ) );
    // Throw an error in the WordPress admin console.
    $error_message = '<p>برای نصب این افزونه باید ابتدا افزونه <a href="https://fa.wordpress.org/plugins/wp-sms/">WP SMS</a> را فعال نمایید.</p>';
    die( $error_message ); // WPCS: XSS ok.
  }
	wpsms_gateway_hack();
}
register_activation_hook( __FILE__, 'wp_sms_ippanel_activate' );

add_action( 'admin_init', 'wpsms_gateway_hack' );
function wpsms_gateway_hack(){
  if ( is_plugin_active( 'wp-sms/wp-sms.php' ) ) {
	if(!is_file(WP_SMS_DIR . 'includes/gateways/class-wpsms-gateway-ippanel.php')){
		$original_file = file_get_contents(__DIR__ . '/class-wpsms-gateway-ippanel.php');
		file_put_contents(WP_SMS_DIR . 'includes/gateways/class-wpsms-gateway-ippanel.php',$original_file);
	}
  }
}

add_filter( 'wp_sms_msg', 'wp_sms_ippanel_msg');
function wp_sms_ippanel_msg($msg){
	if(substr( $msg, 0, strlen(__( 'Your activation code', 'wp-sms' )) ) === __( 'Your activation code', 'wp-sms' )){
		$msgarray = explode(':',$msg);
		$settings = get_option('wpsms_settings');
		$otp_message = $settings['newsletter_otp_text'];
		$msg = str_replace('%code%',$msgarray[1],$otp_message);
	}
	return $msg;
}

add_filter( 'wp_sms_gateway_settings', 'wp_sms_ippanel_otp_settings');
function wp_sms_ippanel_otp_settings($settings){
	if(!isset($settings['gayeway_title'])) {
	$settings['otp'] = Array
        (
            'id' => 'OTP',
            'name' =>'OTP SMS',
            'type' => 'header'
        );

    $settings['newsletter_otp_text'] = Array
        (
            'id' => 'newsletter_otp_text',
            'name' => 'OTP text',
            'type' => 'textarea',
            'desc' => 'کد تأیید: %code%'
        );
	}
	return $settings;
}

add_filter( 'wpsms_gateway_list', 'wp_sms_ippanel_gateway_list');
function wp_sms_ippanel_gateway_list($gateways){
	$gateways['iran']['ippanel'] = 'ippanel.com';
	unset($gateways['iran']['mdpanel']);
	return $gateways;
}


add_action('wp_sms_settings_page','patternscript');
add_action('wp_sms_pro_settings_page','patternscript');
			
function patternscript($form = null){
			add_thickbox();
			?>
<div id="pattern-teach" style="display:none;">
<p>	جهت ارسال سریع پیامک پیشنهاد می شود از پترن استفاده کنید.</p><p>برای ارسال بر اساس پترن، روی ابزار تنظیم پترن کنار هر کادر متن پیامک کلیک کنید و بر اساس دستورالعملی که در ادامه می آید، پترن خود را ثبت نمایید.</p><p>در صورتی که نیاز به ارسال سریع ندارید می توانید در کادرها متن معمولی تایپ کنید و از متغیرهای قالب استفاده نمایید. این نوع ارسال، از خط اختصاصی سریع انجام می شود اما از خطوط خدماتی اشتراکی سامانه با تاخیر انجام می گیرد و پیشنهاد نمی شود.</p><p>	<strong>ثبت پترن اختصاصی:</strong></p><p>	در صورتی که بخواهید متن پیامک خود را در سامانه پیامک تبدیل به پترن نمایید از دستورالعمل زیر استفاده نمایید.</p><p>	وارد پنل پیامک خود شوید و در منوی پنل گزینه &laquo;ارسال بر اساس پترن&raquo; را کلیک کنید.</p><p>	در صفحه ظاهر شده روی دکمه &laquo;+ جدید&raquo; کلیک کنید.</p><p>متن پترن خود را وارد نمایید مانند متن زیر، سپس دکمه ثبت را کلیک نمایید:</p><p>	<strong>مشتری گرامی %name%<br />	سفارش شما به شماره %order-id% ثبت شد.<br/> مبلغ قابل پرداخت: %price%<br/><?php print get_option('blogname'); ?></strong></p><p>	(متن پترن را طبق صلاح خود وارد کنید اما حتما نام فروشگاه خود را ثبت کنید)</p><p>	بعد از ثبت موفق پترن منتظر بمانید تا بین 10 دقیقه تا دو ساعت پترن شما تایید شود. وضعیت تایید یا رد پترن خود را در همان صفحه &laquo;ارسال بر اساس پترن&raquo; پنل پیامک می توانید مشاهده نمایید.&nbsp;</p><p>	پس از اینکه پترن تایید و فعال شد، تنظیمات متن پیامک این افزونه را به شکل زیر انجام دهید:</p><p>روی لینک ابزار تنظیم پترن کلیک کنید و طبق راهنمای آن کد پترن و متغیرهایش را در کادرهای مربوطه وارد نمایید و دکمه "درج پترن در کادر مربوطه" را کلیک کنید</p><p>	سپس دکمه ذخیره تغییرات را کلیک کنید.</p>
</div>
<div id="pattern-tool-wrapper" style="display:none;">
<div id="pattern-tool">
</div>
</div>
<script>
( function ( $ ) {
function activate_wpsms_ippanel_pattern_tools(){
	
	var textarea_index = 1;
	$('.wpsms-tab-group textarea.large-text').not('#wpsms_settings\\[newsletter_form_gdpr_text\\]').each(function(){
		$(this).parents('tr').addClass('wpsms_ippanel_tools trindex-'+textarea_index).attr('id','trindex-'+textarea_index);
		textarea_index++;
	});
	$('tr.wpsms_ippanel_tools textarea').after('<div class="ippanel-tools"><a class="ippanel-patternlearn thickbox button button-secondary" href="#TB_inline?width=800&inlineId=pattern-teach">آموزش ثبت پترن</a><a class="ippanel-patterntool thickbox button button-secondary" href="#TB_inline?width=800&inlineId=pattern-tool-wrapper">ابزار تنظیم پترن</a><a class="ippanel-smstest button button-secondary">تست پیامک</a></div>');
	$('.ippanel-patterntool').on('click',function(){
		var targetvars = $(this).parents('tr').find('.description').text();
		var targetarea = $(this).parents('tr').find('textarea');
		var patternToolText = 'پس از ثبت پترن در سامانه پیامک و تأیید آن، کد پترن را در کادر زیر وارد نمایید:<div id="onlinepattern"><label>کد پترن:</label> <input class="patterncodeinput" placeholder="کد پترن شما" type="text"><div class="pattern-message"></div><div><button class="onlinepcodechecker" type="button">بررسی پترن</button></div><div class="pcodecheckresult"></div><div class="variableshelp hidden">'+targetvars+'</div><div><button class="patterninsert hidden" type="button">ثبت پترن در کادر پیامک</button></div></div><br><div><b>راهنمایی:</b><p class="ippanelpatternstephelp"> متن پیامک خود را در سامانه پیامک > صفحه ارسال بر اساس پترن، تبدیل به پترن کنید. پس از مدتی که پترن شما تأیید شد، کد پترن را از همان صفحه ارسال بر اساس پترن کپی و در کادر فوق درج نمایید.</p></div>';
		$('div#pattern-tool').html(patternToolText);
			
		$('.onlinepcodechecker').on('click',function(){
			pcode = $('#onlinepattern .patterncodeinput').val();
			jQuery.ajax({
				type: 'post',
				async: true,
				url: '<?php print admin_url( 'admin-ajax.php' ); ?>',
				data: {
					action: 'wp_sms_ippanel_CheckPattern',
					patternCode: pcode,
				},
				beforeSend: function(){
					$('#onlinepattern .pattern-message').html('<span class="process-icon-loading">در حال بررسی...</span>');
				},
				success: function (json) {
						
					var obj = JSON.parse(json);
					console.log(obj);
					var message = '';				
							
						  if(obj.status.code == 0){
							$('#onlinepattern .pattern-message').html(obj.data.patternMessage.replace("\n","<br>"));
							var pvars = obj.data.patternParams;
							var output = '<p>لطفاً پارامترهای پترن را با متغیرهای سایت تکمیل نمایید.</p>';
							pvars.forEach(function(value, index, array){
								output += '<div><label>'+value+'</label><input type="text"/></div>';
							});
							$('.pcodecheckresult').html(output);
							$('.variableshelp,.patterninsert').removeClass('hidden');
							$('.onlinepcodechecker').addClass('hidden');
							$('.ippanelpatternstephelp').html('حالا پارامترهای پترن خود را در کادرهای ظاهر شده تکمیل نمایید. از شورتکدهای زیر می توانید استفاده نمایید.');
							var patternoutput = 'pcode:'+pcode;
							$('.patterninsert').click(function(){
								$('.pcodecheckresult div').each(function(){
									if(patternoutput !== '') patternoutput += "\n";
									patternoutput += $(this).find('label').text()+':'+$(this).find('input').val();
								})
								targetarea.val(patternoutput).css('direction','ltr');
								$('.tb-close-icon').click();
							});
						  }else if(obj.status.code == 404){
							  $('#onlinepattern .pattern-message').html('پترن در دسترس نیست. مطمئن شوید که کد پترن را درست و بدون فاصله در چپ و راستش درج کرده اید. اگر به تازگی ثبت کرده اید منتظر باشید تا توسط سامانه تایید شود.');
						  }else if(obj.status.code == 962){
							  $('#onlinepattern .pattern-message').html('نام کاربری یا رمز عبور اشتباه است. اطلاعات ورود پنل پیامکتان را درست وارد کنید.');
						  }else{
							  $('#onlinepattern .pattern-message').html('این پترن در دسترس شما نیست. اگر به تازگی ثبت کرده اید منتظر باشید تا توسط سامانه تایید شود.');
						  }
				},
				complete: function(){
					$('#onlinepattern .pattern-message .process-icon-loading').hide();
				},
			});

			return false;
		});
	});
	$('.ippanel-smstest').on('click',function(){
		$('.send-test-sms-mobile').parent().remove();
	    var trid = $(this).parents('tr').attr('id');
		$(this).after('<div><input class="send-test-sms-mobile" id="'+trid+'_test_mobile" type="text" placeholder="mobile" /><span class="send-test-sms-btn" id="'+trid+'_sendTestSms">ارسال</span><br><span class="result"></span></div>');
	    $('#'+trid+'_sendTestSms').on('click',function(){
	    var phone = $('input#'+trid+'_test_mobile').val();
	    var body = $('#'+trid).find('textarea').val();
		var result = wp_sms_ippanel_test(phone,body,$(this).parent().find('span.result'));
		if(result == 'phonenotfound') {
		    $('input#'+trid+'_test_mobile').focus();
		    return false;
		}
    			
	    });
	    return false;
	});
		
}
function wp_sms_ippanel_test(phone,body,resultbox){
	if ( phone === '' ) {
		alert('لطفاً یک شماره همراه برای دریافت پیامک تست وارد کنید.');
		return 'phonenotfound';
	}
	var data  = {
		action : 'wp_sms_ippanel_test',
		phone : phone,
		body : body,
	};
	resultbox.html('<span style="color:#bbb">درخواست ارسال شد...</span>');
	$.post( ajaxurl, data, function( resp ) {
		if ( resp == '1' ) {
			  resultbox.html('<span style="color:green">پیامک تست ارسال شد.</span>');
		}else{
			  resultbox.html('<span style="color:red">پیامک ارسال نشد.خطای برگشتی: '+resp+'</span>');
		}
	});
	return false;
}
$(document).ready(function(){
	activate_wpsms_ippanel_pattern_tools();
});
	
} )( jQuery );
</script>
<style>
.send-test-sms-mobile {
    padding: 0px 2px!important;
    direction: ltr;
    width: 50%!important;
    margin: 5px;
    display: inline-block!important;
}
.send-test-sms-btn {
	background: #1a7b2f;
	border-color: #1a7b2f;
	color: #fff;
	text-decoration: none;
	text-shadow: none;
	cursor: pointer;
	display: inline-block;
	font-size: 13px;
	line-height: 2.15384615;
	min-height: 30px;
	margin: 0;
	padding: 0 10px;
	border-width: 1px;
	border-style: solid;
	-webkit-appearance: none;
	border-radius: 3px;
	white-space: nowrap;
	box-sizing: border-box;
	font-weight: normal;
}
.ippanel-tools a{
	cursor: pointer;
}
#TB_ajaxContent{
	direction: rtl;
	text-align: right!important;
}
#TB_ajaxContent p {
	margin: 0;
}
#onlinepattern .pattern-message {
	background: #dffde1;
	padding: 10px;
	border-radius: 5px;
	border: 1px solid #bbb;
	margin: 10px;
	color: #666;
}
.ippanel-tools {
	text-align: center;
}
#TB_ajaxContent label {
    width: 100px;
    display: inline-block;
}
.pcodecheckresult >div{
	margin-bottom: 3px;
}
#TB_ajaxContent .variableshelp {
    background: #eee;
    padding: 10px;
    margin: 5px;
    border: 1px solid #aaa;
    border-radius: 5px;
}
</style>
<?php 
}